% Observador substituindo o estado real no controle por realimentao
% de estado

% Seja a planta
G  = zpk([],[0,-1],1);
S  = ss(G);
C  = [1 0];

% Discretizao
T = 0.1;
Sd = c2d(S,0.1,'zoh');

Phi   = Sd.a;
Gamma = Sd.b;

Sdx = ss(Phi,Gamma,eye(2),zeros(2,1),T);

% Polos desejados
qsi = 0.45;
wn  = 2;
sc  = roots([1 2*qsi*wn wn^2]);
zc  = exp(sc*T);

% Controle
K = place(Phi,Gamma,zc)

% Polos desejados para o observador
qsi = 0.45;
wn  = 10;
so  = roots([1 2*qsi*wn wn^2]);
zo  = exp(so*T);

% Projeto do observador'
Lt = place(Phi',C',zo); L = Lt'

% O observador
Phi_o = Phi;
Gamma_o = [Gamma eye(2)]; % a entrada do observador  [u(k) L*ytil(k)]
So = ss(Phi_o,Gamma_o,eye(2),zeros(2,3),T);

% Simulao
sim('ex_obs_ctrl_sim');

% Grfico
figure(2)
clf
h=stairs(tsim,xsim,'-o');
set(h(1),'color',[0 0 1]);
set(h(2),'color',[1 0 0]);
hold on
h=stairs(tsim,xtilsim,'-x');
set(h(1),'color',[0 0 0.4]);
set(h(2),'color',[0.4 0 0]);
grid
legend('x_{1}(t) real','x_{2}(t) real','x_{1}(t) estimado','x_{2}(t) estimado','location','southeast')
xlabel('t (s)')
ylabel('x(t)')
title('Resposta ao degrau da malha fechada (observador na malha)')