
% Realimentao de estado

% Seja a planta
G  = zpk([],[0,-1],1);
S  = ss(G);

% Discretizao
T = 0.1;
Sd = c2d(S,0.1,'zoh');

Phi   = Sd.a;
Gamma = Sd.b;
C     = Sd.c;

% Acesso ao estado
Sdx = ss(Phi,Gamma,eye(2),zeros(2,1),T);

% Polos desejados
qsi = 0.45;
wn  = 2;
sc  = roots([1 2*qsi*wn wn^2]);
zc  = exp(sc*T);

% Controle
K = place(Phi,Gamma,zc)

% Simulao
sim('ex_sf_sim');

% Grfico
figure(1)
stairs(tsim,xsim,'-o')
grid
legend('x_{1}(t) = y(t)','x_{2}(t) = dy(t)/dt')
xlabel('t (s)')
ylabel('x(t)')
title('Resposta ao degrau da malha fechada')